package com.example.afrishop_v3.config;

import com.example.afrishop_v3.util.PayPalUtil;
import com.paypal.base.codec.binary.Base64;
import com.paypal.base.rest.APIContext;
import com.paypal.base.rest.OAuthTokenCredential;
import com.paypal.base.rest.PayPalRESTException;
import com.squareup.okhttp.*;
import net.sf.json.JSONObject;
import org.apache.commons.lang3.builder.ToStringExclude;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.*;
import org.testng.annotations.Test;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.*;


@Configuration
public class PaypalConfig {

    @Value("${paypal.client_app}")
    private String clientId;

    @Value("${paypal.client_secret}")
    private String clientSecret;

    @Value("${paypal.mode}")
    private String mode;



    @Bean
    public Map<String, String> paypalSdkConfig() {
        Map<String, String> sdkConfig = new HashMap<>();
        sdkConfig.put("mode", mode);
        return sdkConfig;
    }

    @Scope("prototype")
    @Bean
    public OAuthTokenCredential authTokenCredential() {
        return new OAuthTokenCredential(clientId, clientSecret, paypalSdkConfig());
    }

    @Scope("prototype")
    @Bean
    public APIContext apiContext() throws  IOException {
        APIContext apiContext = new APIContext(PayPalUtil.getToken());
        apiContext.setConfigurationMap(paypalSdkConfig());
        return apiContext;
    }


}